package com.hotwj.platform.securityManagement.trainingOutline.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.hotwj.platform.securityManagement.trainingOutline.domain.HotTrainingOutline;
import com.hotwj.platform.securityManagement.trainingOutline.domain.bo.HotTrainingOutlineBo;
import com.hotwj.platform.securityManagement.trainingOutline.domain.vo.HotTrainingOutlineVo;
import com.hotwj.platform.securityManagement.trainingOutline.mapper.HotTrainingOutlineMapper;
import com.hotwj.platform.securityManagement.trainingOutline.service.IHotTrainingOutlineService;
import lombok.RequiredArgsConstructor;
import lombok.extern.slf4j.Slf4j;
import org.dromara.common.core.utils.MapstructUtils;
import org.dromara.common.core.utils.StringUtils;
import org.dromara.common.mybatis.core.page.PageQuery;
import org.dromara.common.mybatis.core.page.TableDataInfo;
import org.springframework.stereotype.Service;

import java.util.Collection;
import java.util.List;
import java.util.Map;

/**
 * 培训大纲Service业务层处理
 *
 * @author shihongwei
 * @date 2026-01-14
 */
@Slf4j
@RequiredArgsConstructor
@Service
public class HotTrainingOutlineServiceImpl implements IHotTrainingOutlineService {

    private final HotTrainingOutlineMapper baseMapper;

    /**
     * 查询培训大纲
     *
     * @param id 主键
     * @return 培训大纲
     */
    @Override
    public HotTrainingOutlineVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 分页查询培训大纲列表
     *
     * @param bo        查询条件
     * @param pageQuery 分页参数
     * @return 培训大纲分页列表
     */
    @Override
    public TableDataInfo<HotTrainingOutlineVo> queryPageList(HotTrainingOutlineBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<HotTrainingOutline> lqw = buildQueryWrapper(bo);
        Page<HotTrainingOutlineVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询符合条件的培训大纲列表
     *
     * @param bo 查询条件
     * @return 培训大纲列表
     */
    @Override
    public List<HotTrainingOutlineVo> queryList(HotTrainingOutlineBo bo) {
        LambdaQueryWrapper<HotTrainingOutline> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<HotTrainingOutline> buildQueryWrapper(HotTrainingOutlineBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<HotTrainingOutline> lqw = Wrappers.lambdaQuery();
        lqw.orderByAsc(HotTrainingOutline::getId);
        lqw.eq(bo.getOutlineYear() != null, HotTrainingOutline::getOutlineYear, bo.getOutlineYear());
        lqw.eq(StringUtils.isNotBlank(bo.getOutlineTypes()), HotTrainingOutline::getOutlineTypes, bo.getOutlineTypes());
        lqw.eq(bo.getIsEnabled() != null, HotTrainingOutline::getIsEnabled, bo.getIsEnabled());
        lqw.eq(StringUtils.isNotBlank(bo.getMonthPlanIds()), HotTrainingOutline::getMonthPlanIds, bo.getMonthPlanIds());
        lqw.eq(bo.getIsDeleted() != null, HotTrainingOutline::getIsDeleted, bo.getIsDeleted());
        return lqw;
    }

    /**
     * 新增培训大纲
     *
     * @param bo 培训大纲
     * @return 是否新增成功
     */
    @Override
    public Boolean insertByBo(HotTrainingOutlineBo bo) {
        HotTrainingOutline add = MapstructUtils.convert(bo, HotTrainingOutline.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改培训大纲
     *
     * @param bo 培训大纲
     * @return 是否修改成功
     */
    @Override
    public Boolean updateByBo(HotTrainingOutlineBo bo) {
        HotTrainingOutline update = MapstructUtils.convert(bo, HotTrainingOutline.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(HotTrainingOutline entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 校验并批量删除培训大纲信息
     *
     * @param ids     待删除的主键集合
     * @param isValid 是否进行有效性校验
     * @return 是否删除成功
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteByIds(ids) > 0;
    }
}
